<?php
AKUAdmin_load('AKUAdminForm');
global $REX,$I18N;

$errMsg = '';
$okMsg = '';

$form = AKUAdminForm::factory("moduleform1");
$form->useAjax = true;
$form->setUrl('local_sendForm(this);return false;');

$form->addField('zip','file',0,'','','zip','','');
if(true === $form->isValid()){
  $dir_tmp = aku_admin_getTmpDir();
  if(isset($_FILES['zip']['name']) && ''!= $_FILES['zip']['name']){
    move_uploaded_file($_FILES['zip']['tmp_name'],$dir_tmp.$_FILES['zip']['name']);
    // check if is module
    $zip_rs = zip_open($dir_tmp.$_FILES['zip']['name']);
    $module   = NULL;
    $output   = NULL;
    if(is_resource($zip_rs)){
      while ($zip_entry = zip_read($zip_rs)){
        if(zip_entry_open($zip_rs,$zip_entry)){
          // from the first entry we get the module referrer
          $name =  zip_entry_name($zip_entry);
          if(NULL === $module && ''!=$name){
            $pos = strpos($name,'/');
            if(false === $pos){
              $module = strtolower($name);
            }else{
              $module = strtolower(substr($name,0,$pos));
            }
          }
          if(preg_match('/output\.php$/',strtolower($name))){
            // read the zip entry to output
            $output = '';
          }
        }
      }
      zip_close($zip_rs);
    }
    if(NULL === $module || NULL ===$output){
      // kein korrektes format für eine modul-datei
      $errMsg = $I18N->msg('module_package_error');
      $form->status = false;
      unlink($dir_tmp.$_FILES['zip']['name']);
    }else{
      // falls Ordner im Temp-Verzeichnis schon existiert, löschen 
      if(is_dir($dir_tmp.$module)){
        aku_admin_rmdir($dir_tmp.$module);
      }
      // zip  expandieren in tmp-verz
      if(!aku_admin_unzip($dir_tmp.$_FILES['zip']['name'],$dir_tmp)){
        // unzip erfolgreich, backup entfernen wenn vorhanden
        return array(false,$I18N->msg('error_unzip'));
      }
      // Verzeichnis kopieren (nicht ersetzen!)
      aku_admin_cpdir($dir_tmp.$module,aku_admin_getModuleDir().$module);
      // zip-datei löschen
      unlink($dir_tmp.$_FILES['zip']['name']);
      // add to database
      list($success,$message) = $this->ModuleInstall($module);      
      if(true === $success){
        $okMsg = $message;
      }else{
        $errMsg = $message;
      }
    }
  }
}elseif($form->isSent()){
  $errMsg = $form->getError();
}
##########################################################################
# Ausgabe 
##########################################################################
echo '<div class="structure_block">';
if(''<$errMsg){
  echo '<p class="error" style="background:red;padding:5px;color:white;">'.$errMsg.'</p>';
}

if(''<$okMsg){
  echo '<p class="ok" style="background:green;padding:5px;color:white;">'.$okMsg.'</p>';
}
echo $form->getFormHeader();
echo '<p>'.$I18N->msg('zip_archive').':<br/> ';
echo $form->getField('zip').
  '<div><i>'.$form->getError('zip').'</i></div></p>';
echo '<p><br/><input type="submit" value="'.
  $I18N->msg('upload_and_install').'" onclick="this.value=\''.
  $I18N->msg('please_wait').'\'" /> ';
echo '<a href="" onclick="location.hash=\'AKUAdmin-0-modules\';return false;">'.
  $I18N->msg('form_abort').'</a></p>';
echo $form->getFormFooter();
echo '</div';
