<?php
AKUAdmin_load('AKUAdminForm');
global $REX,$I18N;

$errMsg = '';
$okMsg = '';
$form = AKUAdminForm::factory("clangform1");
$form->useAjax = true;
$form->setUrl('local_sendForm(this);return false;');

$form->addField('name','text',1,$this->getValue('name'),'','text','size="100"','');
$form->addField('code','text',1,$this->getValue('code'),'','/^[a-z]{2}\-[A-Z]{2}$/','size="10"','');
$form->addField('slug','text',1,$this->getValue('slug'),'','/^[a-z]{2}$/','size="10"','');
if(true === $form->isValid()){
  $this->setValue('name',$form->getValue('name'));
  $this->setValue('code',$form->getValue('code'));
  $this->setValue('slug',$form->getValue('slug'));
  $this->save();
  aku_admin_saveSettings(); // writes/updates the settings file
  $return = '{"success":true,"returnto":"AKUAdmin-0-languages"}';
  while (ob_get_level()) { ob_end_clean(); }
  die($return);
}elseif(true===$form->isSent()){
  $errMsg = $form->getError();
}

##########################################################################
# Ausgabe 
##########################################################################
echo '<div id="ClientClangEdit">';
echo '<h1>'.$I18N->msg('clang_edit').'</h1>';
echo $form->getFormHeader();
echo '<p><input type="submit" value="'.$I18N->msg('form_save').'" />&nbsp;'.
  '<a href="" onclick="location.hash=\'AKUAdmin-0-languages\';return false;">'.
  $I18N->msg('form_abort').'</a></p>';

  $this->setValue('name',$form->getValue('name'));
if(''<$errMsg){
  echo '<p class="error">'.$errMsg.'</p>';
}

echo '<table class="rex-table rex-table-mrgn">';
echo '<tbody>';
echo '<tr>'.
  '<td>ID</td><td>'.$this->getValue('id').  '</td>'.
  '</tr>';
echo '<tr>'.
  '<td>'. $I18N->msg('clang_name').'</td>'.
  '<td>'.$form->getField('name').
  '<div><i>'.$form->getError('name').'</i></div>'.
  '</td>'.
  '</tr>';
echo '<tr>'.
  '<td>'. $I18N->msg('clang_code').'</td>'.
  '<td>'.$form->getField('code').' '.$I18N->msg('clang_code_description').
  '<div><i>'.$form->getError('code').'</i></div>'.
  '</td>'.
  '</tr>';
echo '<tr>'.
  '<td>'. $I18N->msg('clang_slug').
  '<td>'.$form->getField('slug').' '.$I18N->msg('clang_slug_description').
  '<div><i>'.$form->getError('slug').'</i></div>'.
  '</td>'.
  '</tr>';
echo '</tbody>';
echo '</table>';
echo $form->getFormFooter();

echo '</div>';
