<?php
AKUAdmin_load('AKUAdminForm');
global $REX,$I18N;

$errMsg = '';
$okMsg = '';

$form = AKUAdminForm::factory("moduleform1");
$form->useAjax = true;
$form->setUrl('local_sendForm(this);return false;');
$form->addField('name','text',1,$this->getValue('name'),'','text','size="100"','');
$isNew = false;
if(0==$this->getValue('id')){
  $isNew = true;
}
/*
if('' != $this->getValue('mod_type')){
  $hasType = true;
  $readonly = ' readonly style="color:grey;background:#eee;"';
}else{
  $hasType = false;
  $readonly = '';
}
*/

$readonly = '';

$form->addField('eingabe','textarea',0,$this->getValue('eingabe'),'','textarea',
  'rows=5 cols=100'.$readonly,'');
$form->addField('ausgabe','textarea',0,$this->getValue('ausgabe'),'','textarea',
  'rows=5 cols=100'.$readonly,'');
if(!$isNew){
  // not a new module
  $form->addField('preview','textarea',0,$this->getValue('preview'),'','textarea',
    'rows=5 cols=100'.$readonly,'');
  $form->addField('presave','textarea',0,$this->getValue('presave'),'','textarea',
    'rows=5 cols=100'.$readonly,'');
  $form->addField('postsave','textarea',0,$this->getValue('postsave'),'','textarea',
    'rows=5 cols=100'.$readonly,'');
  $a=array(
    '1'=>$I18N->msg('action_event_add'),
    '2'=>$I18N->msg('action_event_edit'),
    '4'=>$I18N->msg('action_event_delete')
  );

  function aku_admin_action_mode_array($mode){
    $a = array();
    if(in_array($mode,array(1,3,5,7))){
      $a[] = 1; // add
    }
    if(in_array($mode,array(2,3,6,7))){
      $a[] = 2; // edit
    }
    if(in_array($mode,array(4,5,6,7))){
      $a[] = 4; // delete
    }
    return $a;
  }

  $form->addField('presavemode','multiselect',0,
    aku_admin_action_mode_array($this->getValue('presavemode')),
    $a,'keys','size=3'.$readonly,'');

  $form->addField('postsavemode','multiselect',0,
    aku_admin_action_mode_array($this->getValue('postsavemode')),
    $a,'keys','size=3'.$readonly,'');

  unset($a[4]); // preview mode not for delete
  $form->addField('previewmode','multiselect',0,
    aku_admin_action_mode_array($this->getValue('previewmode')),
    $a,'keys','size=2'.$readonly,'');
}
if(true === $form->isValid()){
  $this->setValue('name',$form->getValue('name'));
  $this->setValue('eingabe',$form->getValue('eingabe'));
  $this->setValue('ausgabe',$form->getValue('ausgabe'));
  if(!$isNew){
    // not a new module
    $this->setValue('preview',$form->getValue('preview'));
    $this->setValue('presave',$form->getValue('presave'));
    $this->setValue('postsave',$form->getValue('postsave'));
    $this->setValue('previewmode',array_sum($form->getValue('previewmode')));
    $this->setValue('presavemode',array_sum($form->getValue('presavemode')));
    $this->setValue('postsavemode',array_sum($form->getValue('postsavemode')));
  }
  $this->save();

  // update the file system
  if(''==$this->getValue('mod_type')){
    // not yet in the file system
    $this->setValue('mod_type','module_'.$this->getValue('id'));
    $this->save();
  }
  $dir = aku_admin_getModuleDir().$this->getValue('mod_type').'/';
  if(!is_dir($dir)){
    mkdir($dir,0755,true);
  }
  file_put_contents($dir.'input.php',$this->getValue('eingabe'));
  file_put_contents($dir.'output.php',$this->getValue('ausgabe'));
  file_put_contents($dir.'preview.php',$this->getValue('preview'));
  file_put_contents($dir.'presave.php',$this->getValue('presave'));
  file_put_contents($dir.'postsave.php',$this->getValue('postsave'));
  $package = 'mod_type : '.$this->getValue('mod_type');
  $package.= "\n".'name : '.$this->getValue('name');
  $package.= "\n".'revision : '.intval($this->getValue('revision'));
  $package.= "\n".'previewmode : '.intval($this->getValue('previewmode'));
  $package.= "\n".'presavemode : '.intval($this->getValue('presavemode'));
  $package.= "\n".'postsavemode : '.intval($this->getValue('postsavemode'));
  file_put_contents($dir.'package.yml',$package);

  $return = '{"success":true,"returnto":"AKUAdmin-0-modules"}';
  while (ob_get_level()) { ob_end_clean(); }
  die($return);
}elseif(true===$form->isSent()){
  $errMsg = $form->getError();
}

##########################################################################
# Ausgabe 
##########################################################################
echo '<div id="ClientClangEdit">';
if($isNew){
  echo '<h1>'.$I18N->msg('create_module').'</h1>';
}else{
  echo '<h1>'.$I18N->msg('module_edit').'</h1>';
}
echo $form->getFormHeader();
echo '<p><input type="submit" value="'.$I18N->msg('form_save').'" />&nbsp;'.
  '<a href="" onclick="location.hash=\'AKUAdmin-0-modules\';return false;">'.
  $I18N->msg('form_abort').'</a></p>';

if(''<$errMsg){
  echo '<p class="error">'.$errMsg.'</p>';
}
echo '<table class="rex-table">';
echo '<tr><th>'.$I18N->msg('module');
if(!$isNew){
  // not a new module
  echo '<tr><td>ID: '.$this->getValue('id');
}
echo '<tr><td>'. $I18N->msg('name').
  '<br/>'.$form->getField('name').
  '<div><i>'.$form->getError('name').'</i></div>';
if('' != $this->getValue('mod_type')){
  // not a new module
  echo '<tr><td>'.$I18N->msg('module_directory').':<br/> ';
  echo realpath(aku_admin_getModuleDir().$this->getValue('mod_type')).'/';
}
echo '<tr><td><strong>'. $I18N->msg('input').'</strong>'.
  '<br/>'.$form->getField('eingabe');
echo '<tr><td><strong>'. $I18N->msg('output').'</strong>'.
  '<br/>'.$form->getField('ausgabe');
if(!$isNew){
  echo '<tr><th >'.$I18N->msg('actions');
  echo '<tr>'.
    '<td><strong>Previev-Action '. $I18N->msg('action_mode_preview').'</strong><br/>'.
    $form->getField('preview').'<br/>'.
    $form->getField('previewmode');
  echo '<tr>'.
    '<td><strong>Presave-Action '. $I18N->msg('action_mode_presave').'</strong><br/>'.
    $form->getField('presave').'<br/>'.
    $form->getField('presavemode');
  echo '<tr>'.
    '<td><strong>Postsave-Action '. $I18N->msg('action_mode_postsave').'</strong><br/>'.
    $form->getField('postsave').'<br/>'.
    $form->getField('postsavemode');
}
echo '</table>';
echo $form->getFormFooter();

echo '</div>';

