<?php
AKUAdmin_load('AKUAdminForm');
global $REX,$I18N;

$errMsg = '';
$okMsg = '';
$isNew = false;
if(0==$this->getValue('id')){
  $isNew = true;
}
$form = AKUAdminForm::factory("templateform1");
$form->useAjax = true;
$form->setUrl('local_sendForm(this);return false;');

$form->addField('name','text',1,$this->getValue('name'),'','text','size="100"','');
$form->addField('active','checkbox',0,$this->getValue('active'),'','','','');

$form->addField('content','textarea',0,$this->getValue('content'),'','textarea',
  'rows=5 cols=100','');

$attr = unserialize($this->getValue('attributes'));
$allcategories = 1;
if (isset($attr['categories']['all'])){
  $allcategories = $attr['categories']['all'];
}
$form->addField('allcategories','checkbox',0,
  $allcategories, '','',
  'onclick="var e=document.getElementById(\'tcatsel\');'.
  'if(this.checked){e.style.display=\'none\';'.
  '}else{'.
  'e.style.display=\'block\';};"', '');
// template in some categories only
$aOptions = aku_admin_getCategoryOptions(); // achtung, liefert array('csw[id]'=>name)
$aSelection = array();
if(isset($attr['categories']) && is_array($attr['categories'])){
  foreach($attr['categories'] as $key=>$val){
    if('all'===$key) continue;
    $aSelection[] = 'csw['.$val.']';
  }
}
$form->addField('tcategories','multicheckbox',0,$aSelection,$aOptions,'keys','','');

if(true === $form->isValid()){
  $old_content = $this->getValue('content');
  $this->setValue('name',$form->getValue('name'));
  $this->setValue('active',$form->getValue('active'));
  $this->setValue('content',$form->getValue('content'));
  // attributes
  $attr['categories']['all'] = $form->getValue('allcategories');
  foreach($form->getValue('tcategories') as $key=>$cat){
    $cat = str_replace('csw[','',$cat);
    $cat = str_replace(']','',$cat);
    $attr['categories'][$key] = $cat;
  }
  $this->setValue('attributes',serialize($attr));
  $this->save();
  // update the file system
  if(''==$this->getValue('tmpl_type')){
    // not yet in the file system
    $this->setValue('tmpl_type','template_'.$this->getValue('id'));
    $this->save();
  }
  $dir = aku_admin_getTemplateDir().$this->getValue('tmpl_type').'/';
  if(!is_dir($dir)){
    mkdir($dir,0755,true);
    file_put_contents($dir.'index.html','');
  }
  file_put_contents($dir.'content.php',$this->getValue('content'));
  $package = 'name : '.$this->getValue('name');
  $package.= "\n".'tmpl_type : '.$this->getValue('tmpl_type');
  $package.= "\n".'revision : '.intval($this->getValue('revision'));
  $package.= "\n".'active : '.intval($this->getValue('active'));
  file_put_contents($dir.'package.yml',$package);

  // return to templates view
  $return = '{"success":true,"returnto":"AKUAdmin-0-templates"}';
  while (ob_get_level()) { ob_end_clean(); }
  die($return);
}elseif(true===$form->isSent()){
  $errMsg = $form->getError();
}

##########################################################################
# Ausgabe 
##########################################################################
if(0==$this->getValue('id')){
  echo '<h1>'.$I18N->msg('create_template').'</h1>';
}else{
  echo '<h1>'.$I18N->msg('edit_template').'</h1>';
}
echo '<div class="structure_block">';
echo $form->getFormHeader();
echo '<p><input type="submit" value="'.$I18N->msg('form_save').'" />&nbsp;'.
  '<a href="" onclick="location.hash=\'AKUAdmin-0-templates\';return false;">'.
  $I18N->msg('form_abort').'</a></p>';

if(''<$errMsg){
  echo '<p class="error">'.$errMsg.'</p>';
}

echo '<table class="rex-table">';
if(!$isNew){
  // not a new template
  echo '<tr><td>ID<td>'.$this->getValue('id');
}
echo '<tr>'.
  '<td>'. $I18N->msg('name').
  '<td>'.$form->getField('name').
  '<div><i>'.$form->getError('name').'</i></div>';

echo '<tr>'.
  '<td>'. $I18N->msg('checkbox_template_active').
  '<td>'.$form->getField('active').' '.
  $I18N->msg('checkbox_template_active_info');
if('' != $this->getValue('tmpl_type')){
  // not a new template
  echo '<tr>'.
    '<td>'. $I18N->msg('template_directory').'<td>';
    echo realpath(aku_admin_getTemplateDir().$this->getValue('tmpl_type')).'/';
}

echo '<tr>'.
  '<td>'. $I18N->msg('header_template').
  '<td>'.$form->getField('content');
echo '<tr>'.
  '<td>'. $I18N->msg('template_categories').
  '<td>'.'<p>'.$form->getField('allcategories').' '.$I18N->msg('all_categories').'</p>';
$style = '';
if(1==$allcategories){
  $style = ' style="display:none;"';
}
echo '<br/><div id="tcatsel"'.$style.'>'.$form->getField('tcategories').'</div>';
echo '</table>';
echo $form->getFormFooter();

echo '</div>';

