<?php

class AKUAddon {
  
  static function factory($addon){
    global $REX;
    $o = new self();
    if(''==$addon){
      return NULL;
    }
    $o->data = array('id'=>$addon);
    return $o;
  }
   
  public function getValue($name){
    if(isset($this->data[$name])){
      return $this->data[$name];
    }else{
      return '';
    }
  }
  function Activate(){
    global $REX,$I18N;
    if(!$REX['USER']->isAdmin()){
      return array(false,$I18N->msg('no_access'));
    }
     $ADDONS    = rex_read_addons_folder();
     $addonManager = new rex_addonManager($ADDONS);
     $warning = $addonManager->activate($this->getValue('id'));
     if(true ===$warning){
       return array(true,'');
     }else{
       return array(false,$warning);
     }
   }
  function Deactivate(){
    global $REX,$I18N;
    if(!$REX['USER']->isAdmin()){
      return array(false,$I18N->msg('no_access'));
    }
     $ADDONS    = rex_read_addons_folder();
     $addonManager = new rex_addonManager($ADDONS);
     $warning = $addonManager->deactivate($this->getValue('id'));
     if(true ===$warning){
       return array(true,'');
     }else{
       return array(false,$warning);
     }
  }
 function Install(){
    global $REX,$I18N;
    if(!$REX['USER']->isAdmin()){
      return array(false,$I18N->msg('no_access'));
    }
     $ADDONS    = rex_read_addons_folder();
     $addonManager = new rex_addonManager($ADDONS);
     $warning = $addonManager->install($this->getValue('id'));
     if(true ===$warning){
       return array(true,str_replace('{0}',$this->getValue('id'),$I18N->msg('addon_installed')));
     }else{
       return array(false,$warning);
     }
 }
 function Uninstall(){
    global $REX,$I18N;
    if(!$REX['USER']->isAdmin()){
      return array(false,$I18N->msg('no_access'));
    }
     $ADDONS    = rex_read_addons_folder();
     $addonManager = new rex_addonManager($ADDONS);
     $warning = $addonManager->uninstall($this->getValue('id'));
     if(true ===$warning){
       return array(true,'');
     }else{
       return array(false,$warning);
     }
 }
  function Delete(){
    global $REX,$I18N;
    if(!$REX['USER']->isAdmin()){
      return array(false,$I18N->msg('no_access'));
    }
    // we call neither deactivation nor uninstall, just deleted the folder
    aku_admin_rmdir($REX['INCLUDE_PATH'].'/addons/'.$this->getValue('id').'/');
    $ADDONS    = rex_read_addons_folder();
    rex_generateAddons($ADDONS);
    return array(true,'');
  }


}





