<IfModule mod_rewrite.c>
RewriteEngine On

### In case ModRewrite doesnt work - remove following comment and try again
#RewriteBase /

### If file exists, use it.
RewriteCond %{REQUEST_FILENAME} !-f
RewriteCond %{REQUEST_FILENAME} !-d
RewriteCond %{REQUEST_FILENAME} !-l

### remove www to avoid double-cart issues in shop
### make it permanent (301) and lett browser know
RewriteCond %{HTTP_HOST} ^www\.(.+)$ [NC]
RewriteCond %{HTTPS}s ^on(s)|
RewriteRule ^ http%2://%1%{REQUEST_URI} [L,R=301]

### Default Rewrite
RewriteRule ^([0-9]*)-([0-9]*)- index.php?article_id=$1&clang=$2&%{QUERY_STRING} [L]
RewriteRule ^([0-9]*)- index.php?article_id=$1&%{QUERY_STRING} [L]

### Slug Rewrite aku_admin
RewriteRule ^([a-z]*)/([0-9]*)- index.php?article_id=$2&rex_clang_slug=$1&%{QUERY_STRING} [L]

### Everything else 
### do not rewrite requests in these directories 
RewriteCond %{REQUEST_URI} !^/redaxo/.*
RewriteCond %{REQUEST_URI} !^/files/.*
RewriteCond %{REQUEST_URI} !^/templates/.*
RewriteCond %{REQUEST_URI} !^/modules/.*
RewriteCond %{REQUEST_URI} !^/tmp/.*
RewriteRule ^(.*)$ index.php?%{QUERY_STRING} [L]

</IfModule>

