<?php
global $REX,$I18N;
AKUAdmin_load('AKUAdminForm');
echo '<h1>'.$I18N->msg('system_info').'</h1>';
echo '<div class="structure_block">';
echo '<table class="rex-table">';
echo '<colset><col width=100><col width=*></colset>';
echo '<tr><td>OS Version<td>'.  $REX['VERSION'].'.'.
  $REX['SUBVERSION'].'.'.$REX['MINORVERSION'];
echo '<tr><td>PHP Version<td>'.phpversion();
echo '<tr><td>MySQL Version<td>'.$REX['MYSQL_VERSION'];
if($REX['USER']->isAdmin() || $REX['USER']->hasPerm('aku_admin[system]')){
  echo '<tr><td>'.$I18N->msg('db_name').'<td>'.
    htmlspecialchars($REX['DB']['1']['NAME']);
  echo '<tr><td>'.$I18N->msg('db_host').'<td>'.
    htmlspecialchars($REX['DB']['1']['HOST']);
}
echo '</table>';
echo '</div>';

// delete cache form
$formc = AKUAdminForm::factory('clearcache');
$formc->useAjax = true;
$formc->setUrl('local_sendForm(this);return false;');
echo '<h2>Cache</h2>';
echo '<div class="structure_block">';
echo '<p>'.$I18N->msg('delete_cache_description').'<br/></p>';
echo $formc->getFormHeader();
echo '<input type="submit" value="'.$I18N->msg('delete_cache').'"/>';
if(true===$formc->isValid()){
  rex_generateAll();
  echo '<p style="background:green;color:white;padding:5px">'.
  $I18N->msg('delete_cache_message').'</p>';
}
echo $formc->getFormFooter();
echo '</div>';


if($REX['USER']->isAdmin() || $REX['USER']->hasPerm('aku_admin[system]')){
  $artoptions = array(0=>$I18N->msg('no_selection'));
  $db = rex_sql::factory();
  $db->setTable($REX['TABLE_PREFIX'].'article');
  $db->setWhere("`startpage`=1 AND `clang`=0 ORDER BY `catname` ASC");
  $db->select('id,name');
  if(0<$db->getRows()){
    while($row = $db->getRow()){
      $artoptions[$row['id']] = $row['name'].' (#'.$row['id'].')';
    }
  }

  $toptions = array(0=>$I18N->msg('no_selection'));
  $db->setTable($REX['TABLE_PREFIX'].'template');
  $db->setWhere("`active`=1 ORDER BY `name` ASC");
  $db->select('id,name');
  if(0<$db->getRows()){
    while($row = $db->getRow()){
      $toptions[$row['id']] = $row['name'].' (#'.$row['id'].')';
    }
  }
  $okMsg = '';
  $errMsg = '';
  $form = AKUAdminForm::factory('admin33');
  $form->useAjax = true;
  $form->setUrl('local_sendForm(this);return false;');
  $form->addField('runmode','select',0,
    isset($REX['AKU_ADMIN_RUNMODE'])?$REX['AKU_ADMIN_RUNMODE']:'prod',
    array('prod'=>$I18N->msg('runmode_production'),
    'dev'=>$I18N->msg('runmode_development')),'keys','','');
  $form->addField('servername','text',1,$REX['SERVERNAME'],'','text','size="50"','');
  $form->addField('server','text',1,$REX['SERVER'],'','text','size="50"','');
  $form->addField('error_email','text',1,$REX['ERROR_EMAIL'],'','email','size="50"','');
  $form->addField('startid','select',0,$REX['START_ARTICLE_ID'],$artoptions,'keys','','');
  $form->addField('notfoundid','select',0,$REX['NOTFOUND_ARTICLE_ID'],$artoptions,'keys','','');
  $form->addField('templateid','select',0,$REX['DEFAULT_TEMPLATE_ID'],$toptions,'keys','','');
  $form->addField('lang','select',0,$REX['LANG'],$REX['LOCALES'],'values','','');
  $form->addField('rewrite','select',0,$REX['MOD_REWRITE']?'TRUE':'FALSE',array('TRUE','FALSE'),'values','','');
  $options = array(
    'default'=>'10-0-Articlename',
    'slug'=>'de/10-Articlename',
    'cat'=>'de/catname/articlename',
  );
  $form->addField('rewrite_mode','select',0,
     isset($REX['AKU_ADMIN_REWRITE'])?$REX['AKU_ADMIN_REWRITE']:'default',
     $options,'keys','','');
  $form->addField('aku_admin_nav','text',0,
     isset($REX['AKU_ADMIN_NAV'])?$REX['AKU_ADMIN_NAV']:'',
     '','text','size="50"','');
  $form->addField('rewrite_multilang','checkbox',0,
     isset($REX['AKU_ADMIN_REWRITE_MULTILANG'])?$REX['AKU_ADMIN_REWRITE_MULTILANG']:'1',
     '','','','');
  

  if(true === $form->isValid()){
    $REX['AKU_ADMIN_NAV'] = $form->getValue('aku_admin_nav');
    $REX['AKU_ADMIN_REWRITE'] = $form->getValue('rewrite_mode');
    $REX['AKU_ADMIN_REWRITE_MULTILANG'] = $form->getValue('rewrite_multilang');
    $REX['AKU_ADMIN_RUNMODE'] = $form->getValue('runmode');
    aku_admin_saveSettings();

    $master_file = $REX['INCLUDE_PATH'] .'/master.inc.php';
    $cont = rex_get_file_contents($master_file);
    $cont = preg_replace("@(REX\['START_ARTICLE_ID'\].?\=.?)[^;]*@", '${1}'.$form->getValue('startid'), $cont);
    $REX['START_ARTICLE_ID'] = $this->getValue('startid');

    $cont = preg_replace("@(REX\['DEFAULT_TEMPLATE_ID'\].?\=.?)[^;]*@", '${1}'.$form->getValue('templateid'), $cont);
    $REX['DEFAULT_TEMPLATE_ID'] = $form->getValue('templateid');
    
    $cont = preg_replace("@(REX\['NOTFOUND_ARTICLE_ID'\].?\=.?)[^;]*@", '${1}'.$form->getValue('notfoundid'), $cont);
    $REX['NOTFOUND_ARTICLE_ID'] = $form->getValue('notfoundid');

    $search = array('\\"', "'", '$');
    $destroy = array('"', "\\'", '\\$');
    $replace = array(
      'search' => array(
        "@(REX\['ERROR_EMAIL'\].?\=.?).*$@m",
        "@(REX\['LANG'\].?\=.?).*$@m",
        "@(REX\['SERVER'\].?\=.?).*$@m",
        "@(REX\['SERVERNAME'\].?\=.?).*$@m",
        "@(REX\['MOD_REWRITE'\].?\=.?).*$@m"
      ),
      'replace' => array(
        "$1'".str_replace($search, $destroy, strtolower($form->getValue('error_email')))."';",
        "$1'".str_replace($search, $destroy, $form->getValue('lang'))."';",
        "$1'".str_replace($search, $destroy, $form->getValue('server'))."';",
        "$1'".str_replace($search, $destroy, $form->getValue('servername'))."';",
        '$1'.strtolower(str_replace($search, $destroy, $form->getValue('rewrite'))).';'
      )
    );
    $cont = preg_replace($replace['search'], $replace['replace'], $cont);

    rex_put_file_contents($master_file, $cont);
    rex_generateAll();
    $okMsg = $I18N->msg('form_saved');
  }elseif(true===$form->isSent()){
    $errMsg = $form->getError();
  }

  echo '<h2>'.$I18N->msg('system_settings').'</h2>';
  echo $form->getFormHeader();
  echo '<div class="structure_block">';

  echo '<p><input type="submit" value="'.$I18N->msg('form_save').'"/>'.
    '<input type="reset" value="'.$I18N->msg('form_reset').'"/></p>';
  if(''<$errMsg){
    echo '<p style="background:orange;color:white;padding:5px">'.$errMsg.'</p>';
  }
  if(''<$okMsg){
    echo '<p style="background:green;color:white;padding:5px">'.$okMsg.'</p>';
  }
  echo '<table class="rex-table">';
  echo '<tr><td>'.$I18N->msg('runmode').
    '<td>'.$form->getField('runmode');
  echo '<tr><td>'.$I18N->msg('specials_settings_servername').' (SERVERNAME)'.
    '<td>'.$form->getField('servername').
    '<div><i>'.$form->getError('servername').'</i></div>';
  echo '<tr><td>'.$I18N->msg('specials_settings_server'). ' (SERVER, BASE)'.
    '<td>'.$form->getField('server').
    '<br/>http://mysite.com/'.
    '<div><i>'.$form->getError('server').'</i></div>';
  echo '<tr><td>'.$I18N->msg('specials_settings_error_email').
    '<td>'.$form->getField('error_email');
  echo '<tr><td>'.$I18N->msg('specials_settings_startarticle').
    '<td>'.$form->getField('startid').
    '<div><i>'.$form->getError('startid').'</i></div>';
  echo '<tr><td>'.$I18N->msg('specials_settings_notfound_article').
    '<td>'.$form->getField('notfoundid').
    '<div><i>'.$form->getError('notfoundid').'</i></div>';
  echo '<tr><td>'.$I18N->msg('specials_settings_default_template').
    '<td>'.$form->getField('templateid').
    '<div><i>'.$form->getError('templateid').'</i></div>';
  echo '<tr><td>'.$I18N->msg('specials_settings_backend_lang').
    '<td>'.$form->getField('lang');
  echo '<tr><td>'.$I18N->msg('special_settings_default_applications').
    '<td>'.$form->getField('aku_admin_nav').'<br/>(app1,app2,app3 ...)';
  echo '<tr><td>'.$I18N->msg('specials_settings_mod_rewrite').
    '<td>'.$form->getField('rewrite');
  echo '<tr><td>'.$I18N->msg('rewrite_mode').
    '<td>'.$REX['SERVER'].$form->getField('rewrite_mode');
  echo '<tr><td>'.$I18N->msg('rewrite_multilang').
    '<td>'.$form->getField('rewrite_multilang').' '.
    $I18N->msg('rewrite_multilang_info');
  if('TRUE'==$REX['MOD_REWRITE']){
    $h = $this->getView('htaccess'); 
    echo '<tr><td>.htaccess<td>'.$I18N->msg('htaccess_info').'<br/>'.
    '<textarea cols=100 style="height:200px;" readonly>'.$h.'</textarea>';
  }
  echo '</table>';
  echo $form->getFormFooter();
  echo '</div>';

}

